//
// Generated file, do not edit! Created by opp_msgtool 6.0 from inet/applications/vehicular/CAMPacket.msg.
//

#ifndef __CAMPACKET_M_H
#define __CAMPACKET_M_H

#if defined(__clang__)
#  pragma clang diagnostic ignored "-Wreserved-id-macro"
#endif
#include <omnetpp.h>

// opp_msgtool version check
#define MSGC_VERSION 0x0600
#if (MSGC_VERSION!=OMNETPP_VERSION)
#    error Version mismatch! Probably this file was generated by an earlier version of opp_msgtool: 'make clean' should help.
#endif

// dll export symbol
#ifndef INET_API
#  if defined(INET_EXPORT)
#    define INET_API  OPP_DLLEXPORT
#  elif defined(INET_IMPORT)
#    define INET_API  OPP_DLLIMPORT
#  else
#    define INET_API
#  endif
#endif

class SequenceNumberTag;
class CAMPacket;
#include "inet/common/INETDefs_m.h" // import inet.common.INETDefs

#include "inet/common/Units_m.h" // import inet.common.Units

#include "inet/common/packet/chunk/Chunk_m.h" // import inet.common.packet.chunk.Chunk

#include "inet/common/TagBase_m.h" // import inet.common.TagBase

// cplusplus {{
        #include "inet/common/geometry/common/Coord.h"
        #define CAM_PACKET 5001
// }}

/**
 * Class generated from <tt>inet/applications/vehicular/CAMPacket.msg:32</tt> by opp_msgtool.
 * <pre>
 * class SequenceNumberTag extends inet::TagBase
 * {
 *     int sequenceNumber;
 * }
 * </pre>
 */
class INET_API SequenceNumberTag : public ::inet::TagBase
{
  protected:
    int sequenceNumber = 0;

  private:
    void copy(const SequenceNumberTag& other);

  protected:
    bool operator==(const SequenceNumberTag&) = delete;

  public:
    SequenceNumberTag();
    SequenceNumberTag(const SequenceNumberTag& other);
    virtual ~SequenceNumberTag();
    SequenceNumberTag& operator=(const SequenceNumberTag& other);
    virtual SequenceNumberTag *dup() const override {return new SequenceNumberTag(*this);}
    virtual void parsimPack(omnetpp::cCommBuffer *b) const override;
    virtual void parsimUnpack(omnetpp::cCommBuffer *b) override;

    virtual int getSequenceNumber() const;
    virtual void setSequenceNumber(int sequenceNumber);
};

inline void doParsimPacking(omnetpp::cCommBuffer *b, const SequenceNumberTag& obj) {obj.parsimPack(b);}
inline void doParsimUnpacking(omnetpp::cCommBuffer *b, SequenceNumberTag& obj) {obj.parsimUnpack(b);}

/**
 * Class generated from <tt>inet/applications/vehicular/CAMPacket.msg:36</tt> by opp_msgtool.
 * <pre>
 * class CAMPacket extends inet::FieldsChunk
 * {
 *     inet::Coord speed;
 *     double beaconRate;
 *     int source;
 *     int sequenceNumber;
 *     double angle;
 *     simtime_t creationTime;
 *     inet::Coord position;
 *     double weight;
 *     double CBT;
 *     double neighCBT;
 *     double power;
 *     double deltaF;
 *     simtime_t neighCBTTimestamp;
 * 
 * 
 * }
 * </pre>
 */
class INET_API CAMPacket : public ::inet::FieldsChunk
{
  protected:
    inet::Coord speed;
    double beaconRate = 0;
    int source = 0;
    int sequenceNumber = 0;
    double angle = 0;
    omnetpp::simtime_t creationTime = SIMTIME_ZERO;
    inet::Coord position;
    double weight = 0;
    double CBT = 0;
    double neighCBT = 0;
    double power = 0;
    double deltaF = 0;
    omnetpp::simtime_t neighCBTTimestamp = SIMTIME_ZERO;

  private:
    void copy(const CAMPacket& other);

  protected:
    bool operator==(const CAMPacket&) = delete;

  public:
    CAMPacket();
    CAMPacket(const CAMPacket& other);
    virtual ~CAMPacket();
    CAMPacket& operator=(const CAMPacket& other);
    virtual CAMPacket *dup() const override {return new CAMPacket(*this);}
    virtual void parsimPack(omnetpp::cCommBuffer *b) const override;
    virtual void parsimUnpack(omnetpp::cCommBuffer *b) override;

    virtual const inet::Coord& getSpeed() const;
    virtual inet::Coord& getSpeedForUpdate() { handleChange();return const_cast<inet::Coord&>(const_cast<CAMPacket*>(this)->getSpeed());}
    virtual void setSpeed(const inet::Coord& speed);

    virtual double getBeaconRate() const;
    virtual void setBeaconRate(double beaconRate);

    virtual int getSource() const;
    virtual void setSource(int source);

    virtual int getSequenceNumber() const;
    virtual void setSequenceNumber(int sequenceNumber);

    virtual double getAngle() const;
    virtual void setAngle(double angle);

    virtual omnetpp::simtime_t getCreationTime() const;
    virtual void setCreationTime(omnetpp::simtime_t creationTime);

    virtual const inet::Coord& getPosition() const;
    virtual inet::Coord& getPositionForUpdate() { handleChange();return const_cast<inet::Coord&>(const_cast<CAMPacket*>(this)->getPosition());}
    virtual void setPosition(const inet::Coord& position);

    virtual double getWeight() const;
    virtual void setWeight(double weight);

    virtual double getCBT() const;
    virtual void setCBT(double CBT);

    virtual double getNeighCBT() const;
    virtual void setNeighCBT(double neighCBT);

    virtual double getPower() const;
    virtual void setPower(double power);

    virtual double getDeltaF() const;
    virtual void setDeltaF(double deltaF);

    virtual omnetpp::simtime_t getNeighCBTTimestamp() const;
    virtual void setNeighCBTTimestamp(omnetpp::simtime_t neighCBTTimestamp);
};

inline void doParsimPacking(omnetpp::cCommBuffer *b, const CAMPacket& obj) {obj.parsimPack(b);}
inline void doParsimUnpacking(omnetpp::cCommBuffer *b, CAMPacket& obj) {obj.parsimUnpack(b);}


namespace omnetpp {

inline any_ptr toAnyPtr(const inet::Coord *p) {if (auto obj = as_cObject(p)) return any_ptr(obj); else return any_ptr(p);}
template<> inline inet::Coord *fromAnyPtr(any_ptr ptr) { return ptr.get<inet::Coord>(); }
template<> inline SequenceNumberTag *fromAnyPtr(any_ptr ptr) { return check_and_cast<SequenceNumberTag*>(ptr.get<cObject>()); }
template<> inline CAMPacket *fromAnyPtr(any_ptr ptr) { return check_and_cast<CAMPacket*>(ptr.get<cObject>()); }

}  // namespace omnetpp

#endif // ifndef __CAMPACKET_M_H

